routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/','PageController@index');


// =================== Proses Belanja ========================
Route::get('cart','CartController@index');
Route::post('cart','CartController@store');
Route::post('cart/checkout','CartController@checkout');
Route::delete('cart/{id}','CartController@destroy');
// =================== End Proses Belanja =====================

Route::get('/user/verify/{token}', 'Auth\RegisterController@verifyUser');
Auth::routes();
Route::get('courses','CourseController@index');
Route::get('course/{slug}','CourseController@show');
Route::get('page/verification','PageController@verification');



Route::get('play/{courseSlug}/{lessonSlug?}','CourseController@play');



// ======================== Halaman Admin =================================
Route::prefix('adminzone')->name('adminzone.')->group(function () {
    Route::resource('category','Admin\CategoryController');
    Route::resource('discount','Admin\DiscountController');
    Route::resource('course','Admin\CourseController');
    Route::get('order','Admin\OrderController@index')->name('order.index');
    Route::get('order/{invoice?}', 'Admin\OrderController@show')->where('invoice', '(.*)')->name('order.show');
    Route::put('order/{invoice?}', 'Admin\OrderController@update')->where('invoice', '(.*)')->name('order.update');
    Route::get('user/{id}/orders','Admin\UserController@orders')->name('user.orders');
    Route::get('user/member','Admin\UserController@member')->name('user.member');
    Route::get('user/{id}/follow','Admin\CourseController@follow')->name('course.follow');
    Route::resource('user','Admin\UserController');
    Route::resource('section','Admin\SectionController');
    Route::resource('lesson','Admin\LessonController');
    Route::get('login','Admin\AuthController@formLogin');
    Route::post('login','Admin\AuthController@login')->name('login');
    Route::get('logout','Admin\AuthController@logout')->name('logout');
    Route::get('dashboard','Admin\PageController@dashboard');
});
// ======================== End Halaman Admin =================================

// ======================== Endpoint API  =================================
Route::prefix('api')->name('api.')->group(function () {
    Route::get('course','Api\CourseController@index');
    Route::get('course/{slug}','Api\CourseController@show');
});
// ======================== End Endpoint API =================================


Route::get('/home', 'HomeController@index')->name('home');

app/Models/Order.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Order extends Model
{
    protected $primaryKey = 'invoice';
    public $incrementing = false;

    public function getCreatedAtAttribute($value)
    {
        return date_format(date_create($value),"d M Y");
    }

    public function accountNumber(){
        return $this->belongsTo('App\Models\AccountNumber','account_number_id','id');
    }

    public function user(){
        return $this->belongsTo('App\User');
    }

    public function orderDetails(){
        return $this->hasMany('App\Models\OrderDetail','invoice','invoice');
    }


    
    protected $fillable = ['user_id','note','invoice','account_number_id','total','payment_status'];
}

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password','slug','photo','role'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];


    public function getPhotoAttribute($value)
    {
        return asset('users/'.$value);
    }

    public function setSlugAttribute($value)
    {
        $this->attributes['slug'] = \Str::slug($value, '-');
    }

    public function orders()
    {
        return $this->hasMany('App\models\Order');
    }

    public function verifyUser()
    {
        return $this->hasOne('App\VerifyUser');
    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Repositories\Eloquent\EloquentUserRepository;
use App\Http\Requests\UserCreateRequest;

class UserController extends Controller
{
    public $UserRepo;

    public function __construct(EloquentUserRepository $UserRepo)
    {
        $this->middleware('auth');
        $this->UserRepo = $UserRepo;
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $data['title'] = "Administrator Dan Trainer";
        $data['users'] = $this->UserRepo->byRole(['administrator','trainer']);
        return view('admin.user.index',$data);
    }

    public function member()
    {
        $data['title'] = "Member";
        $data['users'] = $this->UserRepo->byRole(['member']);
        return view('admin.user.index',$data);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.user.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(UserCreateRequest $request)
    {
        $this->UserRepo->register($request);
        return redirect(route('adminzone.user.index'))->with('message','Success Add New User With Name '.$request->name);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $data['user'] = $this->UserRepo->find($id);
        return view('admin.user.show',$data);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $data['user'] = $this->UserRepo->find($id);
        return view('admin.user.edit',$data);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $input          = $request->all();
        $input['slug']  = \Str::slug($request->name, '-');

        if(empty($request->password))
        {
            unset($input['password']);
        }
        
        if(isset($request->photo))
        {
            $photo              = $request->file('photo');
            $nama_file          = $photo->getClientOriginalName();
            $photo->move('users',$nama_file);
            $input['photo']     = $nama_file;
        }
        $this->UserRepo->update($id,$input);
        return redirect(route('adminzone.user.index'))->with('message','Success Update User With Name '.$request->name);

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $this->UserRepo->delete($id);
        return redirect(route('adminzone.user.index'))->with('message','Success Delete User');
    }

    public function orders($id)
    {
        $data['user']   = $this->UserRepo->find($id);
        $data['orders'] = $this->UserRepo->orders($id);
        return view('admin.user.orders',$data);
    }
}

resources/views/admin/user/create.blade.php
@extends('admin.layout')
@section('title','Create User')
@section('content')
<section class="content">
    <div class="container-fluid">
        <div class="card">
            <div class="card-header">
                <h3 class="card-title">Horizontal Form</h3>
            </div>
            {{ Form::open(['url'=>route('adminzone.user.store'),'class'=>'form-horizontal','files'=>true])}}
            @include('validation')
            @include('admin.user.form')
            </form>
        </div>
    </div>
</section>
@endsection

resources/views/admin/user/edit.blade.php
@extends('admin.layout')
@section('title',$user->name)
@section('content')
<section class="content">
    <div class="container-fluid">
        @include('admin.user.tab')
        <div class="card">
            <div class="card-body">
            {{ Form::model($user,['url'=>route('adminzone.user.update',['id'=>$user->id]),'class'=>'form-horizontal','method'=>'PUT','files'=>true])}}
            @include('validation')
            @include('admin.user.form')
            </form>
            </div>
        </div>
    </div>
</section>
@endsection

resources/views/admin/user/follow.blade.php
@extends('admin.layout')
@section('title','Follow Course')
@section('content')
<section class="content">
  <div class="container-fluid">
      <div class="card">
        @include('admin.user.tab')

          <div class="card-body">
              @include('alert')

              <table id="example1" class="table table-bordered table-striped">
                  <thead>
                      <tr>
                          <th width="7">No</th>
                          <th>Title</th>
                      </tr>
                  </thead>
                  <tbody>
                      @foreach($follows as $follow)
                      <tr>
                          <td>{{ $loop->iteration}}</td>
                          <td>{{ $follow->course->title}}</td>
                      </tr>
                      @endforeach
                  </tbody>
                  <tfoot>
                      <tr>
                          <th>#</th>
                          <th>Title</th>
                      </tr>
                  </tfoot>
              </table>
          </div>
      </div>
  </div>
</section>
@endsection

resources/views/admin/user/form.blade.php
<div class="card-body">
    <div class="form-group row">
        <label for="inputEmail3" class="col-sm-2 col-form-label">Full Name & Role</label>
        <div class="col-sm-7">
           {{ Form::text('name',null,['class'=>'form-control','placeholder'=>'Full Name'])}}
        </div>
        <div class="col-sm-3">
            {{ Form::select('role',['administrator'=>'Administrator','trainer'=>'Trainer','member'=>'Member'],null,['class'=>'form-control'])}}
         </div>
    </div>
    <div class="form-group row">
        <label for="inputEmail3" class="col-sm-2 col-form-label">Email & Password</label>
        <div class="col-sm-5">
            {{ Form::email('email',null,['class'=>'form-control','placeholder'=>'User Email'])}}
         </div>
        <div class="col-sm-5">
           {{ Form::password('password',['class'=>'form-control','placeholder'=>'User Password'])}}
        </div>
    </div>
    <div class="form-group row">
        <label for="inputEmail3" class="col-sm-2 col-form-label">Description</label>
        <div class="col-sm-10">
           {{ Form::textarea('description',null,['class'=>'form-control','placeholder'=>'Description'])}}
        </div>
    </div>
    <div class="form-group row">
        <label for="inputEmail3" class="col-sm-2 col-form-label">Photo</label>
        <div class="col-sm-10">
           {{ Form::file('user_photo',null,['class'=>'form-control'])}}
        </div>
    </div>
</div>

<div class="card-footer">
    <div class="form-group row">
        <label for="inputEmail3" class="col-sm-2 col-form-label"></label>
        <div class="col-sm-10">
            <button type="submit" class="btn btn-info"><i class="fas fa-save"></i> Save Data</button>
            
            <a href="{{ route('adminzone.user.index') }}" class="btn btn-danger"><i class="fas fa-backward"></i> Back</a>
        </div>
    </div>
</div>

resources/views/admin/user/index.blade.php
@extends('admin.layout')
@section('title','Manage '.$title)
@section('content')
<section class="content">
  <div class="container-fluid">
      <div class="card">
          <div class="card-header">
             
              <a href="{{ route('adminzone.user.create') }}" class="btn btn-danger"><i class="fas fa-edit"></i> Add New Data</a>
          </div>
          <div class="card-body">
              @include('alert')

              <table id="example1" class="table table-bordered table-striped">
                  <thead>
                      <tr>
                          <th width="10"></th>
                          <th>Full Name</th>
                          <th>Email</th>
                          @if($title!='Member')
                          <th width="100">Role</th>
                          @endif
                          <th width="10">#</th>
                          <th width="10">#</th>
                      </tr>
                  </thead>
                  <tbody>
                      @foreach($users as $user)
                      <tr>
                          <td># {{ $loop->iteration}}</td>
                          <td>{{ $user->name}}</td>
                          <td>{{ $user->email}}</td>
                          @if($title!='Member')
                            <td width="100">{{ $user->role}}</td>
                          @endif
                          <td><a href="{{ route('adminzone.user.edit',['id'=>$user->id]) }}" class="btn btn-danger btn-sm"><i class="far fa-eye"></i></a></td>
                          <td>
                              {{ Form::open(['url'=>route('adminzone.user.destroy',['id'=>$user->id]),'method'=>'delete'])}}
                              <button type="submit" class="btn btn-danger btn-sm"><i class="far fa-trash-alt"></i></button>
                              {{ Form::close()}}
                          </td>
                      </tr>
                      @endforeach
                  </tbody>
                  <tfoot>
                      <tr>
                          <th>#</th>
                          <th>Full Name</th>
                          <th>Email</th>
                          <th></th>
                          <th></th>
                      </tr>
                  </tfoot>
              </table>
          </div>
      </div>
  </div>
</section>
@endsection

resources/views/admin/user/orders.blade.php
@extends('admin.layout')
@section('title','Orders History From '.$user->name)
@section('content')
<section class="content">
  <div class="container-fluid">
      <div class="card">
        @include('admin.user.tab')
          <div class="card-body">
              @include('alert')

              <table id="example1" class="table table-bordered table-striped">
                  <thead>
                      <tr>
                          <th width="10"></th>
                          <th>Invoice Number</th>
                          <th>Payment To</th>
                          <th>Created At</th>
                          <th>Total</th>
                          <th>Payment Status</th>
                          <th width="10">#</th>
                          {{-- <th width="10">#</th> --}}
                      </tr>
                  </thead>
                  <tbody>
                      @foreach($orders as $order)
                      <tr>
                          <td># {{ $loop->iteration}}</td>
                          <td>{{ $order->invoice}}</td>
                          <td>{{ $order->account_number}} {{ $order->bank_name}}</td>
                          <td>{{ $order->created_at}}</td>
                          <td>{{ $order->total}}</td>
                          <td>{{ $order->payment_status}}</td>
                          <td><a href="{{ route('adminzone.order.show',['id'=>$order->invoice]) }}" class="btn btn-danger btn-sm"><i class="far fa-eye"></i></a></td>
                          {{-- <td>
                              {{ Form::open(['url'=>route('adminzone.order.destroy',['id'=>$order->id]),'method'=>'delete'])}}
                              <button type="submit" class="btn btn-danger btn-sm"><i class="far fa-trash-alt"></i></button>
                              {{ Form::close()}}
                          </td> --}}
                      </tr>
                      @endforeach
                  </tbody>
                  <tfoot>
                      <tr>
                          <th>#</th>
                          <th>Full Name</th>
                          <th>Email</th>
                          <th></th>
                          <th></th>
                      </tr>
                  </tfoot>
              </table>
          </div>
      </div>
  </div>
</section>
@endsection

resources/views/admin/user/show.blade.php
@extends('admin.layout')
@section('title','Profile '.$user->name)
@section('content')
<section class="content">
  <div class="container-fluid">
      <div class="card">
        @include('admin.user.tab')
          <div class="card-body">
              @include('alert')
          </div>
          <table class="table table-bordered">
              <tr>
                  <td></td>
              </tr>
          </table>
      </div>
  </div>
</section>
@endsection

resources/views/admin/user/tab.blade.php
<ul class="nav nav-tabs">
    <li class="nav-item">
      <a class="nav-link {{Request::segment(4)==''?'active':''}}" href="/adminzone/user/{{ Request::segment(3) }}">Profile</a>
    </li>
    <li class="nav-item">
      <a class="nav-link" href="#">Course</a>
    </li>
    <li class="nav-item">
      <a class="nav-link {{Request::segment(4)=='follow'?'active':''}}" href="/adminzone/user/{{ Request::segment(3) }}/follow">Follow Course</a>
    </li>
    <li class="nav-item">
    <a class="nav-link {{Request::segment(4)=='orders'?'active':''}}" href="/adminzone/user/{{ Request::segment(3) }}/orders">Transaction</a>
    </li>
  </ul>